 ifdef AM_XSLTPROCFLAGS
AM_XSLTPROCFLAGS += \
	$(NKUTILS_XSLTPROCFLAGS)
 endif

noinst_LTLIBRARIES += \
	src/libnkutils/libnkutils.la

check_PROGRAMS += \
	$(_libnkutils_tests)

TESTS += \
	$(_libnkutils_tests)

EXTRA_DIST += \
	src/libnkutils/man/libnkutils-man.xml


src_libnkutils_libnkutils_la_SOURCES = \
	src/libnkutils/src/nkutils-glib-compat.h \
	src/config.h

src_libnkutils_libnkutils_la_CFLAGS = \
	$(AM_CFLAGS) \
	$(NKUTILS_CFLAGS)

NKUTILS_CFLAGS = \
	-I$(srcdir)/src/libnkutils/src \
	$(_NKUTILS_INTERNAL_GLIB_CFLAGS)

NKUTILS_LIBS = \
	src/libnkutils/libnkutils.la \
	$(_NKUTILS_INTERNAL_GLIB_LIBS)

NKUTILS_XSLTPROCFLAGS = \
	--path "$(srcdir)/src/libnkutils/man/"

NKUTILS_MANFILES = \
	src/libnkutils/man/libnkutils-man.xml

_libnkutils_tests =

if NK_ENABLE_ENUM
src_libnkutils_libnkutils_la_SOURCES += \
	src/libnkutils/src/enum.c \
	src/libnkutils/src/nkutils-enum.h

_libnkutils_tests += \
	src/libnkutils/tests/enum.test
endif

if NK_ENABLE_TOKEN
src_libnkutils_libnkutils_la_SOURCES += \
	src/libnkutils/src/token.c \
	src/libnkutils/src/nkutils-token.h

_libnkutils_tests += \
	src/libnkutils/tests/token.test
endif

if NK_ENABLE_COLOUR
src_libnkutils_libnkutils_la_SOURCES += \
	src/libnkutils/src/colour.c \
	src/libnkutils/src/nkutils-colour.h

_libnkutils_tests += \
	src/libnkutils/tests/colour.test
endif


#
# Tests
#

# enum
src_libnkutils_tests_enum_test_SOURCES = \
	src/libnkutils/src/nkutils-glib-compat.h \
	src/libnkutils/tests/enum.c

src_libnkutils_tests_enum_test_CFLAGS = \
	$(AM_CFLAGS) \
	$(NKUTILS_CFLAGS) \
	$(_NKUTILS_INTERNAL_TEST_CFLAGS)

src_libnkutils_tests_enum_test_LDADD = \
	$(NKUTILS_LIBS) \
	$(_NKUTILS_INTERNAL_TEST_LIBS)

# token
src_libnkutils_tests_token_test_SOURCES = \
	src/libnkutils/src/nkutils-glib-compat.h \
	src/libnkutils/tests/token.c

src_libnkutils_tests_token_test_CFLAGS = \
	$(AM_CFLAGS) \
	$(NKUTILS_CFLAGS) \
	$(_NKUTILS_INTERNAL_TEST_CFLAGS)

src_libnkutils_tests_token_test_LDADD = \
	$(NKUTILS_LIBS) \
	$(_NKUTILS_INTERNAL_TEST_LIBS)

# colour
src_libnkutils_tests_colour_test_SOURCES = \
	src/libnkutils/src/nkutils-glib-compat.h \
	src/libnkutils/tests/colour.c

src_libnkutils_tests_colour_test_CFLAGS = \
	$(AM_CFLAGS) \
	$(NKUTILS_CFLAGS) \
	$(_NKUTILS_INTERNAL_TEST_CFLAGS)

src_libnkutils_tests_colour_test_LDADD = \
	$(NKUTILS_LIBS) \
	$(_NKUTILS_INTERNAL_TEST_LIBS)
